import getBasePlacement from './getBasePlacement';
import getAltAxis from './getAltAxis';
import getAltLen from './getAltLen';
import { top, right, bottom, left } from '../enums';
export default (({
  reference,
  popper,
  strategy,
  placement,
  scroll
}) => {
  const basePlacement = getBasePlacement(placement);
  const {
    scrollTop,
    scrollLeft
  } = scroll;

  switch (basePlacement) {
    case top:
      return {
        x: reference.x + reference.width / 2 - popper.width / 2 - scrollLeft,
        y: reference.y - popper.height - scrollTop
      };

    case bottom:
      return {
        x: reference.x + reference.width / 2 - popper.width / 2 - scrollLeft,
        y: reference.y + reference.height - scrollTop
      };

    case right:
      return {
        x: reference.x + reference.width - scrollLeft,
        y: reference.y + reference.height / 2 - popper.height / 2 - scrollTop
      };

    case left:
    default:
      return {
        x: reference.x - popper.width - scrollLeft,
        y: reference.y + reference.height / 2 - popper.height / 2 - scrollTop
      };
  }
});